.MODEL SMALL,PASCAL
.STACK 100h
.DATA

S_Punto STRUC
        Coor_X DB ?
        Coor_Y DB ?
        Coor_Z DB ?
S_Punto ENDS

        R_circulo DB 10
        Dist_plano DB 5
        R_esfera DB ?

        Ancho_Img DB 22
        MatrizTrans DW 3600 DUP (0)
        Pto_Q S_Punto <0,0,0>
        Pto_P S_Punto <0,0,0>
        Pto_I S_Punto <0,0,0>

        Distancia DW ?

        Nomb_Fich DB 'MATRIZ.INC',0
        Hand_Fich DW ?

.CODE
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para crear un fichero
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Crear_Fich MACRO Cadena
        mov ax,3C00h             ; Crear el fichero
        xor cx,cx
        mov dx, OFFSET Cadena    ; Nombre del fichero
        int 21h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para abrir un fichero
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Abrir_Fich MACRO Cadena
        mov ax,3D01h             ; Abrir el fichero
        mov dx, OFFSET Cadena    ; Nombre del fichero
        int 21h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para escribir en un fichero
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Escri_Fich MACRO Handle, Tamanyo, Buff
        mov ax,4000h            
        mov bx, Handle
        mov cx, Tamanyo
        mov dx, OFFSET Buff
        int 21h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para cerrar un fichero
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Cerrar_Fich MACRO Handle
        mov ax, 3F00h
        mov bx, Handle
        int 21h
ENDM



;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro que devuelve en AX el cuadrado del valor
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Cuadrado MACRO Valor
        mov al,Valor
        mul al
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro que calcula el valor de la variable Distancia
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Dist PROC
        xor ax,ax
        xor bx,bx
        Cuadrado Dist_plano     ; Obtenemos d^2
        push ax
        Cuadrado Pto_P.Coor_X   ; Obtenemos Px^2
        push ax
        Cuadrado Pto_P.Coor_Y   ; Obtenemos Py^2
        pop bx
        add ax,bx               ; Calculamos Px^2 + Py^2
        push ax
        Cuadrado R_circulo      ; Obtenemos Rc^2
        pop bx
        sub bx,ax               ; Calculamos (Px^2 + Py^2) - Rc^2
        pop ax
        sub ax,bx               ; Calculamos d^2 -((Px^2 + Py^2) -Rc^2)
        mov Distancia, ax       ; Asignamos el valor a Distancia
        ret
Calc_Dist ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para calcular Pto_Q.Coor_Z 
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Qz PROC
        xor ax,ax
        push Distancia
        call Raiz               ; Calculamos SQRT(D)
        add al,1                ; Calculamos 1+SQRT(D)
        mov Pto_Q.Coor_Z, al    ; Asignamos el valor a la variable
        ret
Calc_Qz ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para calcular Pto_I.Coor_X
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Ix PROC
        xor ax,ax
        mov al, Pto_Q.Coor_Z
        add al, Dist_Plano      ; Calculamos (Qz + d)
        push ax
        xor ax,ax
        mov al, Dist_Plano      
        mul Pto_P.Coor_X        ; Calculamos (d * Px)
        pop bx
        div bl                  ; Calculamos (d*Px) / (Qz +d)
        mov Pto_I.Coor_X, al    ; Asignamos el valor a la variable
        ret
Calc_Ix ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para calcular Pto_I.Coor_Y
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Iy PROC
        xor ax,ax
        mov al, Pto_Q.Coor_Z
        add al, Dist_Plano      ; Calculamos (Qz + d)
        push ax
        xor ax,ax
        mov al, Dist_Plano      
        mul Pto_P.Coor_Y        ; Calculamos (d * Py)
        pop bx
        div bl                  ; Calculamos (d*Py) / (Qz +d)
        mov Pto_I.Coor_Y, al    ; Asignamos el valor a la variable
        ret
Calc_Iy ENDP
;###############################################
; Raiz devuelve en AX el valor de la raiz entera
;###############################################
Raiz PROC NEAR USES cx bx , Operando : WORD 
        mov bx, Operando
        xor cx,cx
@bucle:
        inc cl
        Cuadrado cl
        cmp ax,bx
        jle @bucle
        dec cl
        xor ax,ax
        mov al,cl
        ret
Raiz ENDP
;################################################
; Dar_Cateto devuelve en AX el valor del cateto
; opuesto segn el Teorema de Pitagoras
;################################################
Dar_Cateto PROC NEAR USES bx ,Base:BYTE, Cateto: BYTE
        Cuadrado Base
        push ax
        Cuadrado Cateto
        pop bx
        add ax,bx
        push ax
        call Raiz
        ret
Dar_Cateto ENDP

;##################################################
; Transformacion de un punto ,devuelve en AX
;##################################################
Trans_Pto PROC USES bx cx , Cnt_X :BYTE, Cnt_Y:BYTE
LOCAL Medio_Ancho:BYTE
        xor ax,ax
        mov al, Ancho_Img
        shr al,1
        mov Medio_Ancho, al
        
        mov cl,Cnt_Y
        mov ch,Cnt_X
        mov Pto_P.Coor_X, ch    
        mov Pto_P.Coor_Y, cl
        mov Pto_Q.Coor_X, ch
        mov Pto_Q.Coor_Y, cl
        call Calc_Dist  ; Calculamos el valor de D
        call Calc_Qz    ; Calculamos Qz = 1 + SQRT(D)
        call Calc_Ix    ; Calculamos Ix = (d * Qx )/(d + Qz)
        call Calc_Iy    ; Calculamos Iy = (d + Qy )/(d + Qz)
        mov Pto_I.Coor_Z, 0
        mov al, Medio_Ancho
        add al, Pto_I.Coor_Y
        mul Medio_Ancho
        push ax
        mov al, Medio_Ancho
        add al, Pto_I.Coor_X
        pop bx
        add ax,bx
        ret
Trans_Pto ENDP

;##################################################
; Crear_Matriz modifica la matriz de transformacion
;##################################################
Crear_Matriz PROC USES bx cx dx
LOCAL Cnt_X: BYTE,Cnt_Y:BYTE, Desp_Pant :WORD, Desp_Mat :WORD, \
Medio_Ancho :BYTE

        mov al, Ancho_Img       
        shr al,1                ; Dividimos por dos el Ancho
        mov Medio_Ancho, al     ; Lo almacenamos en Medio_Ancho
        xor cx,cx
@Bucle_for1:                    ; Bucle FOR Cnt_X = 0 TO Medio_Ancho para 
                                ; la coordenada X
        mov Cnt_X,cl
        xor cx,cx
   @Bucle_for2:                 ; Bucle FOR Cnt_Y = 0 TO Medio_Ancho -1 para
                                ; la coordenada Y
                mov Cnt_Y,cl
                xor bx,bx
                mov bl,Cnt_X
                push bx         ; Paso de parametros del procedimiento
                push cx         ; Cateto que devuelve un valor en AX 
                call Dar_Cateto
                mov bx,ax       ; Cambiamos el valor de sitio
                mov al,Cnt_Y    ; Calculamos el desplazamiento dentro de la
                mul Medio_Ancho ; matriz de transformacion

                mov cl,Cnt_X    ;\
                xchg ax,cx      ; > Para rellenar ch con 0000h 
                cbw             ;/
                add ax,cx       ; Cnt_Y * Medio_Ancho + Cnt_X
                mov Desp_Mat,ax ; almacenamos el resultado 
                mov cl, R_circulo       ;\
                xchg ax,cx              ; > Para rellenar ch con 0000h 
                cbw                     ;/
                inc ax
                cmp bx, ax              ; El punto esta fuera del circulo de
                mov ax, Desp_Mat
                jl @Es_Menor            ; corte del plano con la esfera
                                ;; El punto esta en la lupa
                        xor bx,bx
                        mov bl,Cnt_X
                        push bx
                        mov bl,Cnt_Y
                        push bx
                        call Trans_Pto

              @Es_Menor:                ; corte del plano con la esfera
                        mov bx,Desp_Mat
                        mov MatrizTrans[bx], ax         ; Asignamos el nuevo
                                                        ; valor
                mov cl,Cnt_Y
                inc cl
                cmp cl,Medio_Ancho
                jl @Bucle_for2
        mov cl,Cnt_X
        inc cl
        mov ch,Medio_Ancho
        dec ch
        cmp cl, ch 
        jl @Bucle_for1
        ret
Crear_Matriz ENDP
;######################################
Codigo PROC
        mov ax, @DATA
        mov ds, ax

;        mov Pto_P.Coor_X, 12
;        mov Pto_P.Coor_Y, 23
;        mov Distancia, 1927
;        mov Pto_Q.Coor_Z, 43

        Crear_Fich Nomb_Fich
        mov Hand_Fich, ax
        call Crear_Matriz
        mov dx,OFFSET MatrizTrans
        Escri_Fich Hand_Fich 3600 MatrizTrans

        mov ax, 4C00h
        int 21h
Codigo ENDP
        END Codigo
     

